unit fmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, JvLabel, Vcl.StdCtrls, Vcl.Mask, JvFormPlacement,
  JvComponentBase, JvAppStorage, JvAppRegistryStorage, JvExStdCtrls, JvMemo,
  JvExMask, JvToolEdit, JvExControls, JvCheckBox;

type
  TForm2 = class(TForm)
    edtCDFFile: TJvFilenameEdit;
    lblFDateSize: TJvLabel;
    JvAppRegistryStorage1: TJvAppRegistryStorage;
    JvFormStorage1: TJvFormStorage;
    txtLog: TJvMemo;
    ckReadOnly: TJvCheckBox;
    procedure edtCDFFileAfterDialog(Sender: TObject; var AName: string;
      var AAction: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure edtCDFFileDropFiles(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ckReadOnlyClick(Sender: TObject);
  private
    procedure ReadTheMap(const filename: string);
    { Private declarations }
  public
    { Public declarations }
    fs: TFileStream;
    procedure DisplayFileBrief;
  end;

var
  Form2: TForm2;

implementation
uses Vcl.Dialogs;

{$R *.dfm}

procedure TForm2.ckReadOnlyClick(Sender: TObject);
begin
   edtCDFFile.ReadOnly := ckReadOnly.Checked;
end;

procedure TForm2.DisplayFileBrief;
begin
   if fs <> nil then begin
      lblfdatesize.caption := inttostr(fs.size)+' bytes';
      txtLog.Lines.LoadFromStream(fs);
   end else begin
      lblfdatesize.caption := 'select file';
      txtLog.Lines.Clear;
   end;
end;

procedure TForm2.edtCDFFileAfterDialog(Sender: TObject; var AName: string;
  var AAction: Boolean);
begin
   if AAction then ReadTheMap(AName)
              else ReadTheMap('');
end;

procedure TForm2.edtCDFFileDropFiles(Sender: TObject);
begin
  ReadTheMap(edtCDFFile.FileName);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  Caption := Application.Title;
  ckReadOnly.Checked := edtCDFFile.ReadOnly;
  //DisplayFileBrief;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  fs.Free;
end;

procedure TForm2.ReadTheMap(const filename: string);
begin
   FreeAndNil(fs);

   if FileExists(filename) then
      fs := TFileStream.Create(filename, fmOpenRead, fmShareDenyWrite);

   DisplayFileBrief;
end;

end.
